Oil Skimming HDU - 4185(匹配板题)

Oil Skimming

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3426    Accepted Submission(s): 1432

Problem Description

Thanks to a certain "green" resources company, there is a new profitable industry of oil skimming. There are large slicks of crude oil floating in the Gulf of Mexico just waiting to be scooped up by enterprising oil barons. One such oil baron has a special plane that can skim the surface of the water collecting oil on the water‘s surface. However, each scoop covers a 10m by 20m rectangle (going either east/west or north/south). It also requires that the rectangle be completely covered in oil, otherwise the product is contaminated by pure ocean water and thus unprofitable! Given a map of an oil slick, the oil baron would like you to compute the maximum number of scoops that may be extracted. The map is an NxN grid where each cell represents a 10m square of water, and each cell is marked as either being covered in oil or pure water.

Input

The input starts with an integer K (1 <= K <= 100) indicating the number of cases. Each case starts with an integer N (1 <= N <= 600) indicating the size of the square grid. Each of the following N lines contains N characters that represent the cells of a row in the grid. A character of ‘#‘ represents an oily cell, and a character of ‘.‘ represents a pure water cell.

Output

For each case, one line should be produced, formatted exactly as follows: "Case X: M" where X is the case number (starting from 1) and M is the maximum number of scoops of oil that may be extracted.

Sample Input

1
6
......
.##...
.##...
....#.
....##
......

Sample Output

Case 1: 3

Source

The 2011 South Pacific Programming Contest

Recommend

lcy

就是一个板题。。。

相邻的两个#建边。。。。然后求最大匹配就好了

用匈牙利就够了  我用的hc

#include <iostream>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <queue>
#include <algorithm>
#include <vector>
#define mem(a, b) memset(a, b, sizeof(a))
using namespace std;
const int maxn = 10010, INF = 0x7fffffff;
int dx[maxn], dy[maxn], cx[maxn], cy[maxn], used[maxn];
int nx, ny, dis, n;
char str[610][610];
int gra[610][610];
vector<int> G[40005];
int dir[4][2] = {{1,0},{-1,0},{0,1},{0,-1}};
int bfs()
{
    queue<int> Q;
    dis = INF;
    mem(dx, -1);
    mem(dy, -1);
    for(int i=1; i<=nx; i++)
    {
        if(cx[i] == -1)
        {
            Q.push(i);
            dx[i] = 0;
        }
    }
    while(!Q.empty())
    {
        int u = Q.front(); Q.pop();
        if(dx[u] > dis) break;
        for(int v=0; v<G[u].size(); v++)
        {
            int i=G[u][v];
            if(dy[i] == -1)
            {
                dy[i] = dx[u] + 1;
                if(cy[i] == -1) dis = dy[i];
                else
                {
                    dx[cy[i]] = dy[i] + 1;
                    Q.push(cy[i]);
                }
            }
        }
    }
    return dis != INF;
}

int dfs(int u)
{
    for(int v=0; v<G[u].size(); v++)
    {
        int i = G[u][v];
        if(!used[i] && dy[i] == dx[u] + 1)
        {
            used[i] = 1;
            if(cy[i] != -1 && dis == dy[i]) continue;
            if(cy[i] == -1 || dfs(cy[i]))
            {
                cy[i] = u;
                cx[u] = i;
                return 1;
            }
        }
    }
    return 0;
}

int hk()
{
    int res = 0;
    mem(cx, -1);
    mem(cy, -1);
    while(bfs())
    {
        mem(used, 0);
        for(int i=1; i<=nx; i++)
            if(cx[i] == -1 && dfs(i))
                res++;
    }
    return res;
}

int main()
{
    int T, kase = 0;
    cin>> T;
    while(T--)
    {
        mem(gra, 0);
        int ans = 0;
        for(int i=0; i<maxn; i++) G[i].clear();
        cin>> n;
        for(int i=0; i<n; i++)
        {
            cin>> str[i];
            for(int j=0; j<n; j++)
            {
                if(str[i][j] == ‘#‘)
                    gra[i][j] = ++ans;

            }

        }
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<n; j++)
            {
                if(str[i][j] == ‘#‘)
                    for(int k=0; k<4; k++)
                    {
                        int nx = i + dir[k][0];
                        int ny = j + dir[k][1];
                        if(str[nx][ny] == ‘#‘ && nx >= 0 && ny >= 0 && nx < n && ny < n)
                            G[gra[i][j]].push_back(gra[nx][ny]), G[gra[nx][ny]].push_back(gra[i][j]);
                    }
            }
        }
        nx = ny = ans;
        printf("Case %d: %d\n",++kase, hk()/2);
    }

    return 0;
}

原文地址:https://www.cnblogs.com/WTSRUVF/p/9310769.html

时间: 2024-07-29 22:48:50

Oil Skimming HDU - 4185(匹配板题)的相关文章

G - Oil Skimming - hdu 4185(二分图匹配)

题意:在大海里有一些石油 ‘#’表示石油, ‘.’表示水,有个人有一个工具可以回收这些石油,不过只能回收1*2大小的石油块,里面不能含有海水,要不就没办法使用了,求出来最多能回收多少块石油 分析:先把数据处理一下,给每一点石油都进行编号,然后查找一下四周联合是否能组成石油块,能的话就连接,因为一点有可能即在左边又在右边,所以最后的结果应该除去 2 ************************************************************************* #

Oil Skimming HDU - 4185

匈牙利 #include <iostream> #include <cstdio> #include <cstring> using namespace std; char mp[660][660]; int g[660][660]; int relate[660][660]; int match[660]; int vis[660]; int k,n; int tmp; int dfs(int u){ int i; for(i = 0; i < tmp; i++

hdu4185 Oil Skimming(二分匹配)

# include <stdio.h> # include <algorithm> # include <string.h> using namespace std; int n,cot; int map[660],vis[660],pp[660][660],u[660][660]; int bfs(int x) { for(int i=1;i<=cot;i++) { if(!vis[i]&&pp[x][i]) { vis[i]=1; if(!ma

hdu 4185 Oil Skimming(二分匹配)

Oil Skimming Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 883    Accepted Submission(s): 374 Problem Description Thanks to a certain "green" resources company, there is a new profitable

HDU 4185 ——Oil Skimming——————【最大匹配、方格的奇偶性建图】

Oil Skimming Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 4185 Description Thanks to a certain "green" resources company, there is a new profitable industry of oil skimming. There ar

hdu 2255 二分图带权匹配 模板题

模板+注解在 http://blog.csdn.net/u011026968/article/details/38276945 hdu 2255 代码: //KM×î´ó×îСƥÅä #include <cstdio> #include <cstring> #include <algorithm> #include <iostream> using namespace std; #define INF 0x0fffffff const int MAXN

hdu KM匹配题集

[HDU]2255 奔小康赚大钱 模板题★1533 Going Home 模板题★2426 Interesting Housing Problem KM★3395 Special Fish KM★2282 Chocolate KM★2813 One fihgt one KM★1853 Cyclic Tour 最小费用圈覆盖★★3488 Tour 最小费用圈覆盖★★3435 A new Graph Game 最小费用圈覆盖★★3722 Card Game 最小费用圈覆盖★★3718 Similar

HDU 4185

http://acm.hdu.edu.cn/showproblem.php?pid=4185 两个挨着的'#'可以配成一对,求最多能配成几对 挨着的'#'就连边,然后求一次最大匹配,答案是最大匹配除以二(因为1 2和2 1这两对匹配实际效果是1,但是会算成2) #include <iostream> #include <cstdio> #include <cstring> using namespace std ; struct node{ int s,t,nxt ;

hdu4185 Oil Skimming

要用1×2的板子尽量多的覆盖##区域,且不能交叉,求至多可以覆盖多少板子. 每一个#向向下或向右相邻的#建边.求最大匹配就可以了. 其实这题数据是比较弱的把,应该是#的个数在600以内把.. #include <iostream> #include <cstdlib> #include <cstring> #include <string> #include <cstdio> #include <cmath> #include <